import{Component,State,Host,Element,Prop,h,Listen,Watch}from"@stencil/core";import applyPolyfills from"../../polyfills/element";applyPolyfills();export class Dropdown{constructor(){this.baseClass="ux-dropdown",this.isOpen=!1,this.activeLabel=null,this.parentContainerSelector="",this.label="",this.placeholder="",this.name="",this.filterable=!1,this.searchPlaceholder="Search",this.hasRadioListItems=!1,this.parentContainer=null,this.mimimumAcceptableHeight=200,this.windowBottomPadding=20,this.getActiveLabel=async()=>{var _a,_b;if(!1===this.hasRadioListItems)return;let checkedRadioButton=null===(_a=this.domNode.querySelector("input[type='radio']:checked"))||void 0===_a?void 0:_a.closest("ux-radio-button");if(checkedRadioButton||""!==this.label||""!==this.placeholder)this.activeLabel=null;else{const firstRadioListItem=null===(_b=this.domNode.querySelector("input[type='radio']"))||void 0===_b?void 0:_b.closest("ux-radio-list-item");firstRadioListItem.checked=!0,checkedRadioButton=firstRadioListItem.querySelector("ux-radio-button")}this.activeLabel=await(null==checkedRadioButton?void 0:checkedRadioButton.getLabel())}}handleBodyClick(event){this.domNode.contains(event.target)||(this.isOpen=!1)}setParentContainer(){""!==this.parentContainerSelector&&(this.parentContainer=this.domNode.closest(this.parentContainerSelector))}componentDidLoad(){this.hasRadioListItems=!!this.dropdownList.querySelector("ux-radio-list-item"),this.getActiveLabel(),this.setParentContainer()}async handleOneChoice(e){!1!==this.hasRadioListItems&&this.dropdownList&&this.dropdownList.contains(e.target)&&(this.activeLabel=await e.target.getLabel(),this.isOpen=!1)}onLabelClick(){this.isOpen=!this.isOpen,!0===this.isOpen?this.enableScrollBarOnOverflow():setTimeout((()=>{!0!==this.isOpen&&(this.dropdownList.style.maxHeight="none",this.dropdownList.style.overflowY="auto")}),300)}enableScrollBarOnOverflow(){if(this.dropdownList){let scrollHeight=this.dropdownList.scrollHeight,windowHeight=window.innerHeight,availableHeight=0,isParentContainerDefined=!1;const listRects=this.dropdownList.getBoundingClientRect(),availableDropHeight=windowHeight-listRects.top;if(null!==this.parentContainer){const parentRects=this.parentContainer.getBoundingClientRect(),listOffsetYToParent=listRects.top-parentRects.top,parentStyles=window.getComputedStyle(this.parentContainer),paddingBottomParent=parseFloat(parentStyles.getPropertyValue("padding-bottom"));availableHeight=parentRects.height-listOffsetYToParent-paddingBottomParent,isParentContainerDefined=!0}else availableHeight=availableDropHeight;const optimalHeight=isParentContainerDefined?availableHeight<availableDropHeight?availableHeight:availableDropHeight-this.windowBottomPadding:availableHeight-this.windowBottomPadding,maxHeight=optimalHeight>this.mimimumAcceptableHeight?optimalHeight:this.mimimumAcceptableHeight;scrollHeight>maxHeight&&(this.dropdownList.style.overflowY="scroll",this.dropdownList.style.maxHeight=maxHeight+"px")}}render(){return h(Host,{class:{[this.baseClass]:!0,[`${this.baseClass}--down`]:this.isOpen}},h("span",{class:{[`${this.baseClass}__label`]:!0,[`${this.baseClass}__label--light`]:this.hasRadioListItems},onClick:this.onLabelClick.bind(this)},h("span",{innerHTML:this.activeLabel||this.label||this.placeholder}),h("ux-icon",{name:"arrow-down"})),h("div",{class:"ux-dropdown__dropdown-locator"},h("ux-list",{filterable:this.filterable,"search-placeholder":this.searchPlaceholder,class:{[`${this.baseClass}__menu`]:!0,[`${this.baseClass}__menu--radio-items`]:this.hasRadioListItems},ref:el=>this.dropdownList=el},h("slot",null))))}static get is(){return"ux-dropdown"}static get originalStyleUrls(){return{$:["dropdown.scss"]}}static get styleUrls(){return{$:["dropdown.css"]}}static get properties(){return{parentContainerSelector:{type:"string",mutable:!1,complexType:{original:"string",resolved:"string",references:{}},required:!1,optional:!1,docs:{tags:[],text:"Set parent container to calculate max width of dropdown and activating scrollbar overflow if necessary"},attribute:"parent-container-selector",reflect:!1,defaultValue:'""'},label:{type:"string",mutable:!1,complexType:{original:"string",resolved:"string",references:{}},required:!1,optional:!1,docs:{tags:[{text:'since version 2.13.2, use "placeholder" insead',name:"deprecated"}],text:"Text displayed on the Dropdown"},attribute:"label",reflect:!0,defaultValue:'""'},placeholder:{type:"string",mutable:!1,complexType:{original:"string",resolved:"string",references:{}},required:!1,optional:!1,docs:{tags:[],text:"Text displayed inside the Dropdown"},attribute:"placeholder",reflect:!1,defaultValue:'""'},name:{type:"string",mutable:!1,complexType:{original:"string",resolved:"string",references:{}},required:!1,optional:!1,docs:{tags:[],text:"Name Identifies the dropdown in a bigger context (for example in forms, filters)"},attribute:"name",reflect:!0,defaultValue:'""'},filterable:{type:"boolean",mutable:!1,complexType:{original:"boolean",resolved:"boolean",references:{}},required:!1,optional:!1,docs:{tags:[],text:"This toggles the text-input to filter the dropdown items"},attribute:"filterable",reflect:!0,defaultValue:"false"},searchPlaceholder:{type:"string",mutable:!1,complexType:{original:"string",resolved:"string",references:{}},required:!1,optional:!1,docs:{tags:[],text:"The placeholder string for the search field"},attribute:"search-placeholder",reflect:!1,defaultValue:'"Search"'}}}static get states(){return{isOpen:{},activeLabel:{},hasRadioListItems:{}}}static get elementRef(){return"domNode"}static get watchers(){return[{propName:"parentContainerSelector",methodName:"setParentContainer"}]}static get listeners(){return[{name:"click",method:"handleBodyClick",target:"body",capture:!1,passive:!1},{name:"uxRadioButtonChange",method:"handleOneChoice",target:"window",capture:!1,passive:!1}]}}